      options/extend_source
      subroutine DALEKS_profile( ch, num )
      !
      implicit none
      integer*4 status,ch, num, str_to_int4
      character text*80
      include 'daleks_inc.for'
      !
      max_DR_distance   = 50
      max_forward_speed = 9
      max_reverse_speed = 5
      max_health = 5
      d( num ).ang = 1
      d( num ).lin = 2
      d( num ).col = 2
      !
      open ( unit=ch, file='DALEKS_DIR:daleks_profile', status='UNKNOWN',
     .       carriagecontrol='list', readonly )
      !
      do while ( status .EQ. 0 )
         !
         read ( unit=ch, fmt='(a)', IOstat=status ) text
         !
         if ( status .EQ. 0 .and.
     .        text(1:1) .NE. '!' ) then
            !
            if ( str_to_int4( text(2:3) ) .EQ. num ) then
               !
               if ( str_to_int4( text(5:6) ) .GE. 5 ) then
                  max_DR_distance = str_to_int4( text(5:6) )
               else
                  print *, 'ERROR: death-ray range in DALEKS_PROFILE.DAT < 5'
               end if
               !
               if ( str_to_int4( text(8:9) ) .GE. 1 ) then
                  max_forward_speed = str_to_int4( text(8:9) )
               else
                  print *, 'ERROR: max forward speed in DALEKS_PROFILE.DAT < 1'
               end if
               !
               if ( str_to_int4( text(11:12) ) .GE. 1 ) then
                  max_reverse_speed = str_to_int4( text(11:12) )
               else
                  print *, 'ERROR: max reverse speed in DALEKS_PROFILE.DAT < 1'
               end if
               !
               if ( str_to_int4( text(14:15) ) .GE. 1 ) then
                  max_health = str_to_int4( text(14:15) )
               else
                  print *, 'ERROR: max health in DALEKS_PROFILE.DAT < 1'
               end if
               !
               if ( str_to_int4( text(17:19) ) .GE. 1 ) then
                  d( num ).lin = str_to_int4( text(17:19) )
               else
                  print *, 'ERROR: line # in DALEKS_PROFILE.DAT < 1'
               end if
               !
               if ( str_to_int4( text(21:23) ) .GE. 1 ) then
                  d( num ).col = str_to_int4( text(21:23) )
               else
                  print *, 'ERROR: column # in DALEKS_PROFILE.DAT < 1'
               end if
               !
               if ( str_to_int4( text(25:26) ) .GE. 1 .and.
     .              str_to_int4( text(25:26) ) .LE. 8       ) then
                  d( num ).ang = str_to_int4( text(25:26) )
               else
                  print *, 'ERROR: angle in DALEKS_PROFILE.DAT <1 or >8'
               end if
               !
               !
            end if
            !
         end if
         !
      end do
      !
      call daleks_next_place( d( num ).lin, d( num ).col, d( num ).ang,
     .                        d( num ).glin, d( num ).gcol )
      !
      close ( ch )
      !
      !
      end


      options/extend_source
      subroutine daleks_next_place( lin, col, ang, temp_lin, temp_col )
      !
      !
      implicit none
      integer*4 lin, col, ang, temp_lin, temp_col
      !
      if ( ang .EQ. 1 ) then  
         temp_col = col
         temp_lin = lin - 1
      else if ( ang .EQ. 2 ) then
         temp_lin = lin - 1
         temp_col = col + 1
      else if ( ang .EQ. 3 ) then
         temp_col = col + 1
         temp_lin = lin
      else if ( ang .EQ. 4 ) then
         temp_lin = lin + 1
         temp_col = col + 1
      else if ( ang .EQ. 5 ) then
         temp_lin = lin + 1
         temp_col = col
      else if ( ang .EQ. 6 ) then
         temp_lin = lin + 1
         temp_col = col - 1
      else if ( ang .EQ. 7 ) then
         temp_col = col - 1
         temp_lin = lin
      else if ( ang .EQ. 8 ) then
         temp_lin = lin - 1
         temp_col = col - 1
      else
         stop 'PROG ERROR c'
      end if
      !
      end
      


      options/extend_source
      subroutine DALEKS_read_world( ch )
      !
      implicit none
      include 'daleks_inc.for'
      integer*4 ch, status, length
      character text*255
      !
      open( unit=ch, name='DALEKS_DIR:DALEKS_WORLD.DAT', status='OLD',
     .      carriagecontrol='list', IOstat=status, readonly )
      !
      if ( status .NE. 0 ) then
         print *, 'Fortran error #', status
         print *, 'Is the DALEKS_DIR: logical valid and does it ' //
     .       'point to a readable and writable directory?'
         stop 'could not open the DALEKS_DIR:DALEKS_WORLD file'
      end if
      !
      wld_height = 0
      wld_width = 0
      do while ( status .EQ. 0 )
         !
         read( unit=ch, fmt='(Q,A)', IOstat=status ) length, text
         !
         if ( status .EQ. 0 ) then
            !
            if ( wld_height .EQ. max_wld_height ) then
               print *, 'world is too height i.e. >', max_wld_height
               status = -1 ! emulate an EOF
               goto 49 ! just use world so far
            end if
            !
            wld_height = wld_height + 1
            wld( wld_height ) = text
            if ( length .GT. wld_width ) wld_width = length
            !
         end if
         !
49    end do
      !
      if ( status .NE. -1 ) then ! Error other than EOF
         print *, 'Fortran error #', status
         stop 'could not read the DALEKS_WORLD file'
      end if
      !
      if ( wld_height .LT. win_height .or.
     .     wld_width .LT. win_width ) then
         stop 'DALEKS_WORLD is too short or narrow'
      end if
      !
      close ( unit=ch )
      !
      end




      options /extend_source
      subroutine daleks_inkey( code )
      !
      !
      !
      implicit none                                                 
      !
      include '($SSDEF)'
      include '($SYSSRVNAM)'
      include '($IODEF)'
      include 'daleks_inc.for'
      !
      character chr*1
      integer*4 st, time_out, function_code, escape, code
      !
      structure /TT_read_IOSB/
         integer*2   status
         integer*2   bytes_read
         integer*4   %fill
      end structure
      record/TT_read_IOSB/ IOSB
      !
      structure /term_mask_struct/
         integer*2 size
         integer*2 filler
         integer*4 address
      end structure
      record/term_mask_struct/term_mask
      !
      if ( kb_ch .EQ. 0 ) then
         !
         st = sys$assign( 'SYS$INPUT:', KB_ch,, )
         !
         if ( st .NE. ss$_normal ) then
            !
            print *, 'ERROR on opening channel for keyboard input with status', st
            call lib$stop( %val( st ) )
            !
         end if
         !
      end if
      !
      time_out = 0
      !
      term_mask.size = 0
      term_mask.filler = 0   ! use short form of term mask.
      term_mask.address = 0  
      !
      IOSB.status = 0
      IOSB.bytes_read = 0
      !
      !
      function_code = IO$_READVBLK + IO$M_TIMED + IO$M_NOECHO + IO$M_NOFILTR
      !
      escape = 0
      !                
10    chr = char( 0 )
      st = sys$qiow( %val( 1 ),
     .               %val( kb_ch ),
     .               %val( function_code ),
     .               IOSB, , ,
     .               %REF( chr ),
     .               %val( len( chr ) ),
     .               %val( time_out ), %val( %loc( term_mask ) ),
     .               %val( 0 ), %val( 0 ) )
      !
      if ( st .NE. ss$_normal ) then
         !
         print *, '** Error on SYS$QIOW keyboard read ** ', st
         call lib$stop( %val( st ) )
         !
      end if
      !
      code = ichar( chr )
      !
      if ( code .EQ. 27 ) then
         escape = -1
         goto 10
      end if
      !
      if ( escape .NE. 0 ) then
         !
         if ( code .EQ. 91 ) goto 10   ! character `['
         !
         if ( code .EQ. 65 ) code = up_key
         if ( code .EQ. 66 ) code = down_key
         if ( code .EQ. 68 ) code = left_key
         if ( code .EQ. 67 ) code = right_key
         !
      end if
      !
      !
      end


